package bot

import (
	"fmt"
	"testing"

	"gitlab.com/zlyzol/dexarbot/bot/order"
	"gitlab.com/zlyzol/dexarbot/bot/orderbook"
	"gitlab.com/zlyzol/dexarbot/ctx"
	"gitlab.com/zlyzol/dexarbot/db"
)

type MockOrderExecutor struct {
}
func (MockOrderExecutor) Execute(tAsset, qAsset string, amount, limit float64, orderSide int8) (*order.Order, error) {
	fmt.Print("Mock order Execute")
	return nil, nil
}
func (MockOrderExecutor) BurstExecute(orders []*order.Order) error {
	fmt.Print("Mock order BurstExecute")
	return nil
}

func TestAdjustTickAndLot(t *testing.T){
	cx := &ctx.Context{Config: &ctx.Config{}}
	cx.Config.TradeMin = 30
	cx.Config.TradedAsset = "RUNE-B1A"
	cx.Config.CrossAsset = "BNB"
	cx.Config.BaseAsset = "BUSD-BD1"
	cx.TickAndLotTradeBase = [2]uint64{100, 100000000} // 0.00000100, 1.00000000
	cx.TickAndLotTradeCross = [2]uint64{1, 100000000}  // 0.00000001, 1.00000000
	cx.TickAndLotCrossBase = [2]uint64{10000, 100000}  // 0.00010000, 0.00100000
	limit, amount := cx.AdjustTickAndLot(cx.Config.CrossAsset+"_"+cx.Config.BaseAsset, 0.071, 14.2083)
	if limit != 0.071 || amount != 14.208 {
		t.Errorf("AdjustTickAndLot failed. Expected price / amount: [%v / %v], got: [%v / %v]", 0.071, 14.208, limit, amount)
	}
}

func TestExecuteArbTrade(t *testing.T) {
	obRuneUsd, obBnbUsd, obRuneBnb := GetTestOrderbooks()
	obRuneBnb.Bids[0].Price = 0.00790242
	obRuneBnb.Asks[0].Price = 0.00630005
	obRuneBnb.Asks[1].Price = 0.00639898
	obRuneUsdMerged := orderbook.Merge(obRuneBnb, obBnbUsd, [2]uint64{100, 100000000})
	arbRes := orderbook.ChekArbOpportunity(obRuneUsd, obRuneUsdMerged, 30000)
	if arbRes == nil {
		t.Error("Not found arbitrage opportunity where it shoud be found")
	}
	// arb opp test 4 end
	cx := &ctx.Context{Config: &ctx.Config{}}
	bot := New(cx)

	cx.Config.TradeMin = 30
	cx.Config.TradedAsset = "RUNE-B1A"
	cx.Config.CrossAsset = "BNB"
	cx.Config.BaseAsset = "BUSD-BD1"

	cx.TickAndLotTradeBase = [2]uint64{100, 100000000} // 0.00000100, 1.00000000
	cx.TickAndLotTradeCross = [2]uint64{1, 100000000}  // 0.00000001, 1.00000000
	cx.TickAndLotCrossBase = [2]uint64{10000, 100000}  // 0.00010000, 0.00100000

	var dbTrade *db.Trade
	exe := &MockOrderExecutor{}

	/*
	obTB, obCB, obTC := GetTestOrderbooks()
	obMerged := orderbook.Merge(bot.obTC, bot.obCB, [2]uint64{100, 100000000})
	bot.DebugOB(obTB, obTC, obCB)
	arbRes = orderbook.ChekArbOpportunity(obTB, obMerged, 30000)
	if arbRes == nil {
		t.Error("Not found arbitrage opportunity where it shoud be found")
	}
	dbTrade := bot.ExecuteArbTrade(exe, arbRes)
	if dbTrade == nil {
		t.Errorf("Arbitrage failed")
	}

	obRuneUsd, obBnbUsd, obRuneBnb = GetTestOrderbooks2()
	obRuneUsdMerged = orderbook.Merge(obRuneBnb, obBnbUsd, [2]uint64{100, 100000000})
	arbRes = orderbook.ChekArbOpportunity(obRuneUsd, obRuneUsdMerged, 30000)
	if arbRes == nil {
		t.Error("Not found arbitrage opportunity where it shoud be found")
	}
	dbTrade = bot.ExecuteArbTrade(exe, arbRes, obRuneUsd, obRuneUsdMerged, obRuneBnb, obBnbUsd)
	if dbTrade == nil {
		t.Errorf("Arbitrage failed")
	}


	obRuneUsd, obBnbUsd, obRuneBnb = GetTestOrderbooks3()
	obRuneUsdMerged = orderbook.Merge(obRuneBnb, obBnbUsd, [2]uint64{100, 100000000})
	arbRes = orderbook.ChekArbOpportunity(obRuneUsd, obRuneUsdMerged, 30000)
	if arbRes == nil {
		t.Error("Not found arbitrage opportunity where it shoud be found")
	}
	dbTrade = bot.ExecuteArbTrade(exe, arbRes, obRuneUsd, obRuneUsdMerged, obRuneBnb, obBnbUsd)
	if dbTrade != nil {
		t.Errorf("Arbitrage rejection failed")
	}

	obRuneUsd, obBnbUsd, obRuneBnb = GetTestOrderbooks4()
	obRuneUsdMerged = orderbook.Merge(obRuneBnb, obBnbUsd, [2]uint64{100, 100000000})
	arbRes = orderbook.ChekArbOpportunity(obRuneUsd, obRuneUsdMerged, 30000)
	if arbRes == nil {
		t.Error("Not found arbitrage opportunity where it shoud be found")
	}
	dbTrade = bot.ExecuteArbTrade(exe, arbRes, obRuneUsd, obRuneUsdMerged, obRuneBnb, obBnbUsd)
	if dbTrade == nil {
		t.Errorf("Arbitrage failed")
	}
*/
	obRuneUsd, obBnbUsd, obRuneBnb = GetTestOrderbooks5()
	bot.DebugOB(obRuneUsd, obRuneBnb, obBnbUsd)
	obRuneUsdMerged = orderbook.Merge(obRuneBnb, obBnbUsd, [2]uint64{100, 100000000})
	arbRes = orderbook.ChekArbOpportunity(obRuneUsd, obRuneUsdMerged, 30000)
	if arbRes == nil {
		t.Error("Not found arbitrage opportunity where it shoud be found")
	}
	dbTrade = bot.ExecuteArbTrade(exe, arbRes)
	if dbTrade == nil {
		t.Errorf("Arbitrage failed")
	}

}
func GetTestOrderbooks() (*orderbook.Orderbook, *orderbook.Orderbook, *orderbook.Orderbook) {
	e0 := orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}
	obRuneUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{
			{orderbook.SimpleOrderbookEntry{Price: 0.119217, Amount: 200.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.118967, Amount: 200.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.116835, Amount: 2177.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.115371, Amount: 200.000000}, e0},
		},
		Asks: orderbook.OrderbookEntries{
			{orderbook.SimpleOrderbookEntry{Price: 0.119301, Amount: 200.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.119302, Amount: 43.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.119318, Amount: 52.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.119720, Amount: 5020.000000}, e0},
		},
	}
	obBnbUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{
			{orderbook.SimpleOrderbookEntry{Price: 17.288200, Amount: 5.264000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 17.229400, Amount: 14.578000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 17.170500, Amount: 5.960000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 17.112200, Amount: 3.925000}, e0},
		},
		Asks: orderbook.OrderbookEntries{
			{orderbook.SimpleOrderbookEntry{Price: 17.440800, Amount: 40.592000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 17.463200, Amount: 17.523000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 17.467800, Amount: 30.418000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 17.490400, Amount: 13.090000}, e0},
		},
	}

	obRuneBnb := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{
			{orderbook.SimpleOrderbookEntry{Price: 0.00670003, Amount: 746.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.00670000, Amount: 2087.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.00665001, Amount: 2000.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.00665000, Amount: 10000.000000}, e0},
		},
		Asks: orderbook.OrderbookEntries{
			{orderbook.SimpleOrderbookEntry{Price: 0.00699896, Amount: 69.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.00699898, Amount: 13724.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.00699900, Amount: 16854.000000}, e0},
			{orderbook.SimpleOrderbookEntry{Price: 0.00704878, Amount: 77548.000000}, e0},
		},
	}
	return obRuneUsd, obBnbUsd, obRuneBnb
}

func GetTestOrderbooks2() (*orderbook.Orderbook, *orderbook.Orderbook, *orderbook.Orderbook) {
	obRuneUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price: 0.100552, Amount: 200}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.100175, Amount: 100}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.096658, Amount: 100}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.09509, Amount: 6400}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.090901, Amount: 15819}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0909, Amount: 12000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.090001, Amount: 5555}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0851, Amount: 24000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0811, Amount: 1911}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0801, Amount: 48000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.080001, Amount: 6249}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0751, Amount: 97534}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.070001, Amount: 7142}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.060001, Amount: 8333}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.000106, Amount: 59614}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price: 0.101, Amount: 200}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.104001, Amount: 62}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.1098, Amount: 1669}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.11, Amount: 1136}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.112717, Amount: 164}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.11337, Amount: 200}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.113472, Amount: 200}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.113473, Amount: 200}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.114069, Amount: 200}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.11407, Amount: 100}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.118, Amount: 1531}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.12, Amount: 1613}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.13, Amount: 19031}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.14, Amount: 14273}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.15, Amount: 15000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.16, Amount: 13910}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.17, Amount: 13910}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 40, Amount: 150}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}},
	}
	obBnbUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price: 15.5198, Amount: 5.597}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.4806, Amount: 45.845}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.4676, Amount: 25.315}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.4155, Amount: 3.87}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.3656, Amount: 11.839}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.3156, Amount: 3.695}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.2643, Amount: 13.47}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.213, Amount: 11.674}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.1609, Amount: 4.483}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.1099, Amount: 15.802}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.0586, Amount: 71.951}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.0074, Amount: 66.104}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 14.9561, Amount: 46.567}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 14.9048, Amount: 51.78}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 14.8448, Amount: 49.61}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 14.7848, Amount: 39.173}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 14.7147, Amount: 60.696}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 14.6466, Amount: 56.186}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 14.5786, Amount: 43.982}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 14.529, Amount: 43.301}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price: 15.6288, Amount: 136.254}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.657, Amount: 100.434}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.6852, Amount: 124.277}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.7103, Amount: 136.112}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.7348, Amount: 161.243}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.7394, Amount: 3.176}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.7593, Amount: 132.327}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.785, Amount: 241.192}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.8106, Amount: 132.44}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.8348, Amount: 263.315}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.865, Amount: 177.34}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.8948, Amount: 217.468}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.9241, Amount: 193.781}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.9494, Amount: 186.342}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.9726, Amount: 122.061}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 15.9998, Amount: 139.295}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 16.0251, Amount: 250.347}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 16.0504, Amount: 526.038}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 16.0719, Amount: 381.277}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 16.097, Amount: 254.474}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}},
	}
	obRuneBnb := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price: 0.00656365, Amount: 14453}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00656363, Amount: 343}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00656355, Amount: 1000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00656291, Amount: 9904}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00656003, Amount: 268}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00656001, Amount: 365}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00655501, Amount: 11000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.006555, Amount: 12200}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00651, Amount: 2000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0065, Amount: 905}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00647008, Amount: 2000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00647007, Amount: 300}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00647002, Amount: 504}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00645123, Amount: 900}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00641008, Amount: 24099}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00641, Amount: 3000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00640001, Amount: 1000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00638888, Amount: 50}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0063838, Amount: 5364}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0063711, Amount: 800}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price: 0.00672507, Amount: 300}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.006853, Amount: 15165}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0068538, Amount: 20759}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00685397, Amount: 279}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.006985, Amount: 9900}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.007098, Amount: 2492}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00709995, Amount: 91}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0071, Amount: 10000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00711991, Amount: 10000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00711994, Amount: 11719}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00712, Amount: 18000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00714049, Amount: 6605}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00716, Amount: 22000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.0071667, Amount: 408}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00716678, Amount: 25000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00728888, Amount: 100}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.007299, Amount: 24000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00733, Amount: 1700}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.007338, Amount: 11000}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}, {orderbook.SimpleOrderbookEntry{Price: 0.00735, Amount: 150}, orderbook.SimpleOrderbookEntry{Price: 0, Amount: 0}}},
	}
	return obRuneUsd, obBnbUsd, obRuneBnb
}

// from log filte to go code:
// basic edit
// 1. replace Normal with SimpleOrderbookEntry
// 2. replace ' Amount:' wth ', Amount:'
// 3. replace ' Ex:' wth ', Ex:'
// 4. replace '} {SimpleOrderbookEntry:' wth '}, {SimpleOrderbookEntry:'
// 5. replace 'SimpleOrderbookEntry:' with 'orderbook.SimpleOrderbookEntry'
// 6. replace '}, Ex:{' with '}, orderbook.SimpleOrderbookEntry{'
func GetTestOrderbooks3() (*orderbook.Orderbook, *orderbook.Orderbook, *orderbook.Orderbook) {
	obRuneUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.096658, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.09509, Amount:6400}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.090901, Amount:15819}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0909, Amount:12000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.090001, Amount:5555}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0851, Amount:24000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0811, Amount:1911}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0801, Amount:48000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.080001, Amount:6249}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0751, Amount:97534}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.070001, Amount:7142}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.060001, Amount:8333}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.000106, Amount:59614}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.104001, Amount:62}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1098, Amount:1669}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.11, Amount:1136}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.112717, Amount:164}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.11337, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.113472, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.113473, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.114069, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.11407, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.118, Amount:1531}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.12, Amount:1613}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.13, Amount:19031}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.14, Amount:14273}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.15, Amount:15000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.16, Amount:13910}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.17, Amount:13910}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:40, Amount:150}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
	}
	obBnbUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:15.7867, Amount:9.073}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.7352, Amount:22.888}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.6836, Amount:24.152}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.6293, Amount:25.321}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.5712, Amount:22.642}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.5198, Amount:5.597}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.4676, Amount:25.315}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.3912, Amount:38.926}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.3512, Amount:13.331}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.3277, Amount:49.781}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.2642, Amount:35.427}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.2128, Amount:66.722}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.1614, Amount:33.774}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.11, Amount:47.603}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.0586, Amount:71.951}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.0074, Amount:66.104}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:14.9561, Amount:46.567}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:14.9048, Amount:51.78}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:14.8448, Amount:49.61}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:14.7798, Amount:56.222}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:15.9015, Amount:86.82}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.9369, Amount:126.737}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.967, Amount:109.485}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.9971, Amount:110.219}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0242, Amount:114.015}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0485, Amount:250.613}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0728, Amount:141.642}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0997, Amount:117.506}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.1276, Amount:157.638}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.1556, Amount:154.267}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.1783, Amount:235.231}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.201, Amount:172.788}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.2237, Amount:250.293}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.2484, Amount:197.868}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.2745, Amount:153.018}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.3, Amount:0.37}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.3022, Amount:199.233}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.3284, Amount:249.256}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.3394, Amount:3.176}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.361, Amount:257.229}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
	}
	obRuneBnb := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.0065998, Amount:1}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00641009, Amount:120}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00641008, Amount:22099}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00641, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00638888, Amount:50}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0063838, Amount:5364}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0063711, Amount:800}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00637008, Amount:276}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00636802, Amount:17204}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00633302, Amount:400}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.006333, Amount:41080}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00633, Amount:1150}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0063208, Amount:53}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00625103, Amount:1432}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00625, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0062317, Amount:30065}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00623129, Amount:52}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00622888, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00621, Amount:86500}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0062001, Amount:1726}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0062, Amount:43282}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00615, Amount:1669}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0061, Amount:341}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00608888, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00608, Amount:2600}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00601101, Amount:1000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00601, Amount:3165}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.006, Amount:1712}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00588888, Amount:150}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.005886, Amount:142}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00586, Amount:3703}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00581112, Amount:3353}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00567522, Amount:9000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0056666, Amount:7000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00560505, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00551001, Amount:2000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00551, Amount:4174}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0054987, Amount:300}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00547685, Amount:2862}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00545, Amount:6706}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00534, Amount:292}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00531, Amount:25000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0053, Amount:20000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00526, Amount:4288}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0052, Amount:40429}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0051499, Amount:13369}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00510505, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.005, Amount:380}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00486, Amount:18156}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00485971, Amount:3200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.004836, Amount:2344}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00450777, Amount:150}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0045, Amount:700}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00438, Amount:267}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00435778, Amount:6674}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.004194, Amount:17818}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00411112, Amount:99999}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.004, Amount:2000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00364111, Amount:99999}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0032949, Amount:27264}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00204449, Amount:58705}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.002, Amount:1466}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00073152, Amount:6834}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:7.315e-05, Amount:13678}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:7.3e-07, Amount:273957}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:6.5e-07, Amount:3.076923e+06}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.00659983, Amount:38}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0065999, Amount:9995}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00679915, Amount:14159}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00679917, Amount:11184}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00679926, Amount:4648}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00679935, Amount:17652}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00679943, Amount:1745}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0067995, Amount:9900}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00679983, Amount:26035}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0068538, Amount:20759}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00685397, Amount:279}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007, Amount:2000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007098, Amount:2492}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00709995, Amount:91}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0071, Amount:10000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00711991, Amount:10000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00711994, Amount:11719}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00712, Amount:18000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00714049, Amount:6605}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00716, Amount:22000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0071667, Amount:408}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00716678, Amount:25000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00728888, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007299, Amount:24000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00733, Amount:1700}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007338, Amount:11000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00735, Amount:150}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007368, Amount:356}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00745, Amount:78016}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00746, Amount:60553}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00748718, Amount:6095}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0074887, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00748888, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007498, Amount:6157}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0075, Amount:3600}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00751999, Amount:2419}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00754995, Amount:102}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0075887, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0076, Amount:16233}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00760506, Amount:880}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00764, Amount:45950}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00765, Amount:8}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00765888, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0076887, Amount:559}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0077465, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00776488, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00788998, Amount:2502}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00788999, Amount:1e+06}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0081, Amount:728}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0085, Amount:4092}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0091, Amount:1092}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00999999, Amount:5823}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.011, Amount:593}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.01228888, Amount:38861}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.014999, Amount:2911}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0152886, Amount:677}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.01647466, Amount:1873}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.01752824, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.01873, Amount:1127}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0673145, Amount:6707}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:13, Amount:40}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
	}
	return obRuneUsd, obBnbUsd, obRuneBnb
}


func GetTestOrderbooks4() (*orderbook.Orderbook, *orderbook.Orderbook, *orderbook.Orderbook) {
	obRuneUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.105918, Amount:87}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1, Amount:3}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.099119, Amount:81}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.098968, Amount:41}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.098812, Amount:41}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.098479, Amount:42}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.098127, Amount:40}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.096658, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.09509, Amount:6400}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.090901, Amount:15819}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0909, Amount:12000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.090001, Amount:5555}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0851, Amount:24000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0811, Amount:1911}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0801, Amount:48000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.080001, Amount:6249}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0751, Amount:97534}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.070001, Amount:7142}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.060001, Amount:8333}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.000106, Amount:59614}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.10736, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1098, Amount:1669}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.11, Amount:1136}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.112717, Amount:164}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.11337, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.113472, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.113473, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.114069, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.11407, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.118, Amount:1531}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.16, Amount:13910}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.17, Amount:13910}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.18, Amount:20644}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.19, Amount:14636}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.2, Amount:14637}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:40, Amount:150}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
	}
	obBnbUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:15.8396, Amount:28.458}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.8394, Amount:19.347}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.79, Amount:0.316}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.7878, Amount:22.687}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.7354, Amount:22.242}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.6836, Amount:24.152}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.6293, Amount:25.321}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.5552, Amount:33.966}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.4732, Amount:34.023}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.3912, Amount:38.926}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.3512, Amount:13.331}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.3277, Amount:49.781}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.2642, Amount:35.427}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.2128, Amount:66.722}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.1614, Amount:56.953}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.11, Amount:47.603}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.0586, Amount:71.951}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.0074, Amount:66.104}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:14.9561, Amount:46.567}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:14.9048, Amount:51.78}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:15.9818, Amount:13.048}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16, Amount:0.5}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0019, Amount:60.19}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.022, Amount:47.374}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0426, Amount:18.025}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0643, Amount:52.551}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0657, Amount:42.699}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.086, Amount:87.484}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.108, Amount:116.182}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.13, Amount:154.097}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.1537, Amount:215.583}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.1767, Amount:251.673}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.1983, Amount:121.343}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.2223, Amount:172.092}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.2462, Amount:119.077}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.2745, Amount:153.018}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.3, Amount:0.37}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.3014, Amount:140.922}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.3312, Amount:256.635}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.3394, Amount:3.176}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
	}
	obRuneBnb := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.00646033, Amount:983}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00642, Amount:669}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00637007, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00637006, Amount:16000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00637, Amount:21667}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00635002, Amount:84900}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00635, Amount:4971}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00633335, Amount:20380}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00633, Amount:1150}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0063208, Amount:53}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00625103, Amount:432}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00625, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00623173, Amount:1979}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00623172, Amount:1000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0062317, Amount:30065}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00623129, Amount:52}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00622888, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0062001, Amount:1726}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0062, Amount:782}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00615, Amount:1669}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.0065, Amount:892}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00659994, Amount:60}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00659996, Amount:14404}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00659999, Amount:95}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0066, Amount:3521}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00676279, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00683, Amount:3600}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00683888, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00685378, Amount:14851}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0068538, Amount:20759}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00685397, Amount:279}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00698288, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007, Amount:2000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00709797, Amount:9900}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007098, Amount:2492}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00709995, Amount:91}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0071, Amount:10000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00711991, Amount:10000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00711994, Amount:11719}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00712, Amount:18000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}}, 
	}
	return obRuneUsd, obBnbUsd, obRuneBnb
}

func GetTestOrderbooks5() (*orderbook.Orderbook, *orderbook.Orderbook, *orderbook.Orderbook) {
//{ArbRes:{BidNdx:0 AskNdx:0 BidLeft:0.34384775110598353 AskLeft:0.3283746023062143} PriceVol1:{Price:0, Amount:0} PriceVol2:{Price:0, Amount:0} PriceVol3:{Price:0, Amount:0} Trade:[{Price:0, Amount:0} {Price:0, Amount:0} {Price:0, Amount:0}] 
	obRuneUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.107247, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.10305, Amount:315}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.102885, Amount:1}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.101001, Amount:12019}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.101, Amount:5495}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.10095, Amount:4398}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.10035, Amount:3318}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1, Amount:2250}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0965, Amount:1502}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0957, Amount:80}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.092, Amount:6141}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.091, Amount:7582}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.09001, Amount:5554}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.09, Amount:6155}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0875, Amount:3805}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0855, Amount:5192}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0825, Amount:3103}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.08001, Amount:6249}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.08, Amount:5000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.075, Amount:3706}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.072, Amount:5000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.07001, Amount:7141}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.068, Amount:7352}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0655, Amount:6778}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.062, Amount:3629}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.06, Amount:2533}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.058, Amount:8620}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.055, Amount:6109}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:4.4e-05, Amount:123306}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.107584, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.10935, Amount:2349}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.10975, Amount:8091}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.10999, Amount:5045}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1108, Amount:11922}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.115, Amount:1531}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1158, Amount:9594}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1188, Amount:7474}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.12, Amount:150000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1206, Amount:8291}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1226, Amount:8988}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1245, Amount:9012}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1269, Amount:4373}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1296, Amount:14567}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1345, Amount:11620}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1378, Amount:9586}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1399, Amount:10536}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1425, Amount:8736}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.1463, Amount:9924}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}}, 
	}
	obBnbUsd := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:16.3341, Amount:5.583}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.3332, Amount:4.521}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.2788, Amount:17.776}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.2254, Amount:19.015}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.18, Amount:20.24}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.1732, Amount:10.091}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.1204, Amount:6.015}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0663, Amount:2.978}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.0142, Amount:16.26}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.962, Amount:16.253}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.9093, Amount:36.66}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.8566, Amount:27.048}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.8049, Amount:43.816}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.7527, Amount:57.788}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.6966, Amount:54.044}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.6406, Amount:64.986}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.6, Amount:0.001}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.582, Amount:76.107}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.5233, Amount:9.907}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:15.4595, Amount:48.797}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}}, 
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:16.4499, Amount:0.5}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.45, Amount:30.296}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.4632, Amount:82.524}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.48, Amount:3.355}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.4846, Amount:27.936}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.4897, Amount:121.426}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.4999, Amount:1.3}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.5009, Amount:2.7}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.5062, Amount:52.471}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.5278, Amount:119.147}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.5529, Amount:120.974}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.579, Amount:125.751}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.6056, Amount:135.702}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.6339, Amount:74.604}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.6626, Amount:115.951}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.6912, Amount:204.043}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.7167, Amount:210.518}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.7351, Amount:1.686}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.7482, Amount:146.565}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:16.75, Amount:0.4}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
	}
	obRuneBnb := &orderbook.Orderbook{
		Bids: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.00662002, Amount:191}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00662, Amount:12176}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.006595, Amount:2426}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00659122, Amount:2954}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00651112, Amount:2304}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00651, Amount:1654}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0065, Amount:243}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00641106, Amount:2000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00641104, Amount:54}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00641101, Amount:3702}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.006411, Amount:22361}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0064, Amount:5941}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00638888, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0063501, Amount:130}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0063, Amount:15000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00629, Amount:175}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00620011, Amount:500}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0062001, Amount:1250}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00618888, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00610002, Amount:20000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00610001, Amount:73900}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00605, Amount:2000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00601, Amount:3949}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00600003, Amount:1000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.006, Amount:4167}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00595, Amount:2500}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00590112, Amount:1000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.005901, Amount:1922}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0059004, Amount:1694}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0059003, Amount:13191}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00590029, Amount:3}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00590015, Amount:1500}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0059, Amount:3017}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00588888, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00587, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00586, Amount:5829}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00571, Amount:3502}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0057, Amount:2000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00562, Amount:2778}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0055055, Amount:545}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00542, Amount:3845}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.005417, Amount:10174}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00531, Amount:25000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.005301, Amount:15000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0053, Amount:5000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.005297, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00525, Amount:4499}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00523001, Amount:1000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00523, Amount:10000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00521, Amount:4414}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00520015, Amount:9886}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00519043, Amount:9433}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0051, Amount:5100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0049, Amount:5398}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00487, Amount:13395}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0048, Amount:11776}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0047, Amount:5417}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0046297, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0045001, Amount:150}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0045, Amount:1100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00446676, Amount:3357}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0044, Amount:300}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0042, Amount:300}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00419494, Amount:17818}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00411112, Amount:99999}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00364111, Amount:99999}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0032949, Amount:27976}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00204449, Amount:58705}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0007422, Amount:6734}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:7.422e-05, Amount:13495}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:7.7e-07, Amount:259614}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:6.6e-07, Amount:3.030303e+06}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
		Asks: orderbook.OrderbookEntries{{orderbook.SimpleOrderbookEntry{Price:0.00671245, Amount:400}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00686985, Amount:13866}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00686987, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0068699, Amount:10552}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00687, Amount:16435}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.006875, Amount:17992}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00689094, Amount:2500}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00689095, Amount:4390}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00695939, Amount:19298}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00695949, Amount:65}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0069595, Amount:819}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00695999, Amount:1977}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00698385, Amount:5000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00699983, Amount:5000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007, Amount:7826}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00708888, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00715, Amount:221995}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00718899, Amount:5000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007199, Amount:2698}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0072, Amount:97931}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00728888, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00729489, Amount:5000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0072949, Amount:6605}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007337, Amount:815}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00733799, Amount:5000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00746333, Amount:880}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007468, Amount:5680}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0074887, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00748888, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00748999, Amount:100}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0075, Amount:2720}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00751999, Amount:815}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007546, Amount:2492}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.007548, Amount:3412}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00758509, Amount:102}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0075887, Amount:3000}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00762, Amount:1622}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00768, Amount:60553}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00768888, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00788888, Amount:200}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00888888, Amount:300}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.00970052, Amount:249}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.0133952, Amount:1127}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.01965, Amount:1873}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}, {orderbook.SimpleOrderbookEntry{Price:0.451, Amount:40}, orderbook.SimpleOrderbookEntry{Price:0, Amount:0}}},
	}
	return obRuneUsd, obBnbUsd, obRuneBnb
}